import { Button, Space, Modal, FormInstance } from "antd";
import { inject, observer } from "mobx-react";
import BTable from "@/components/b_table";
import { useEffect, useState } from "react";
import { Store } from "antd/lib/form/interface";
import React from "react";
import { columns, defaultConfig } from "./dep_config";
import "./dep.less";
import SimpleForm from "@/components/form/simple_form";

const Dep = (props: Store) => {
  const { depStore } = props;
  const [isModalOpen, setIsModalOpen] = useState<boolean>(false);
  const formRef = React.useRef<FormInstance>(null);
  const [userId, setId] = useState<Number | null>(null);
  const [record, setRecord] = useState<any>(null);
  useEffect(() => {
    depStore.getlist();
  }, []);

  const addHandler = () => {
    setIsModalOpen(true);
  };
  return (
    <div className="contentBox">
      <Space direction="vertical" size="middle" style={{ display: "flex" }}>
        <Button type="default" onClick={() => addHandler()}>
          添加部门
        </Button>
        <BTable
          store={depStore}
          scroll={{ x: "max-content" }}
          columns={columns}
          dataSource={depStore.list}
        />

        <Modal
          title={!userId ? "添加" : "编辑"}
          width={800}
          open={isModalOpen}
          afterClose={() => formRef.current?.resetFields()}
          onOk={() => formRef.current?.submit()}
          okText="确定"
          cancelText="取消"
          onCancel={() => {
            setId(null);
            setIsModalOpen(false);
          }}
        >
          <SimpleForm
            formName={"user_form"}
            formRef={formRef}
            colProps={25}
            onFinish={() => {
              depStore.add(formRef.current?.getFieldsValue());
            }}
            createCallback={() => {
              formRef.current?.setFieldsValue(record);
            }}
            formDatas={defaultConfig}
          ></SimpleForm>
        </Modal>
      </Space>
    </div>
  );
};

export default inject("depStore")(observer(Dep));
